#==============================================================================#
#                        Copyright 2022-2024 ArchaicSoft                       #
#                                                                              #
# Boost Software License - Version 1.0 - August 17th, 2003                     #
#                                                                              #
# Permission is hereby granted, free of charge, to any person or organization  #
# obtaining a copy of the software and accompanying documentation covered by   #
# this license (the "Software") to use, reproduce, display, distribute,        #
# execute, and transmit the Software, and to prepare derivative works of the   #
# Software, and to permit third-parties to whom the Software is furnished to   #
# do so, all subject to the following:                                         #
#                                                                              #
# The copyright notices in the Software and this entire statement, including   #
# the above license grant, this restriction and the following disclaimer,      #
# must be included in all copies of the Software, in whole or in part, and     #
# all derivative works of the Software, unless such copies or derivative       #
# works are solely in the form of machine-executable object code generated by  #
# a source language processor.                                                 #
#                                                                              #
# THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR   #
# IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,     #
# FITNESS FOR A PARTICULAR PURPOSE, TITLE AND NON-INFRINGEMENT. IN NO EVENT    #
# SHALL THE COPYRIGHT HOLDERS OR ANYONE DISTRIBUTING THE SOFTWARE BE LIABLE    #
# FOR ANY DAMAGES OR OTHER LIABILITY, WHETHER IN CONTRACT, TORT OR OTHERWISE,  #
# ARISING FROM, OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER  #
# DEALINGS IN THE SOFTWARE.                                                    #
#==============================================================================#

## A node based controller which simplifies actions and transitions to a mini-script format.
@icon("res://addons/asfw/state_machine/icon.svg")
class_name StateMachine extends Node
func get_class() -> String: return "StateMachine"
static func get_instance_base_type() -> StringName: return "StateMachine"

# state properties
@export var animator       : AnimationPlayer

var current_state          : State = State.new({})
var _current_state         : String
@export var _default_state : String
@export var states         : Dictionary

# (optional) user-defined conditional for allowing input
func input_enabled() -> bool: return true

# state machine automation

func _ready() -> void:
	# remove incompatible dict entries and instance scripts
	for key in states.keys():
		if states[key] is State: continue
		if (
			not states[key] is Script or
			states[key].get_instance_base_type() != "State"
		): states.erase(key); continue
		states[key] = states[key].new()
	
	# boot the default state if one is provided
	if not _default_state.is_empty():
		goto_default()

func _physics_process(delta: float) -> void:
	if input_enabled():
		current_state.process_input.call(delta)
	current_state.process_physics.call(delta)

func _process(delta: float) -> void:
	current_state.process.call(delta)

# state management functions

func set_default(state_name: String, state: State = null) -> void:
	_default_state = state_name
	if state != null: write_state(state_name, state)

func add_state(state_name: String, state: State) -> bool:
	# this function won't replace existing states
	if states.has(state_name): return false
	
	states[state_name] = state
	return true

func write_state(state_name: String, state: State) -> void:
	states[state_name] = state

func remove_state(state_name: String) -> void:
	if not states.has(state_name): return
	states.erase(state_name)

# state transition function
func goto(goto_state: String) -> bool:
	# make sure we have a state pull functions from
	if not states.has(goto_state): return false
	
	# invoke our state ending
	if not current_state.exit.call(goto_state):
		return false # exit early if internal function canceled the switch
	
	# load out new state
	var new_state : State = states[goto_state]
	
	# initialize our new state
	if not new_state.enter.call(_current_state):
		return false # exit early if internal function canceled the switch
	
	#-------------#
	#-  success  -#
	#-------------#
	
	# transition our new state to our current in trackers
	_current_state = goto_state
	current_state = new_state
	
	# call animation
	if animator != null: play_anim(goto_state)
	
	return true

# state transition function
func goto_default() -> bool:
	# go to our default state
	if not _default_state.is_empty():
		return goto(_default_state)
	
	# we didn't have a default state, attempt to go to the first state
	var keys := states.keys()
	
	 # no keys found
	if keys.size() < 1:
		return false
	
	return goto(keys[0])

# auto-set when state changed
func play_anim(anim: String, speed: float = 1.0) -> void:
	if (
		animator == null or
		not animator.has_animation(anim)
	): return
	
	if animator.speed_scale != speed:
		animator.speed_scale = speed
	
	if animator.current_animation != anim:
		animator.current_animation = anim
		animator.play()
